<template>
  <div
    v-if="isTinyUserCenterEnabled"
    class="over-lay absolute top-0 right-0 left-0 bottom-0 h-screen"
    @click="tiggerTinyUserCenter"
  ></div>
  <div
    class="mobile-tiny-user-center-style-2"
    :class="{ 'has-unread-message': isHasUnreadMessage }"
  >
    <div
      class="flex items-center justify-center tiny-button w-6 h-6 cursor-pointer rounded-2xl"
      :class="{ 'tiny-button-rotate': isTinyUserCenterEnabled }"
      @click="tiggerTinyUserCenter"
    >
      <div class="w-[12.67px] flex place-content-between">
        <div v-for="item in 3" :key="item" class="tiny-dot"></div>
      </div>
    </div>
    <div
      class="rounded user-center-container z-50 overflow-y-auto"
      :class="{ 'user-center-container-active': isTinyUserCenterEnabled }"
    >
      <div class="relative">
        <div
          class="flex flex-col py-2"
          :class="{ 'custom-backdrop-blur': !auth }"
        >
          <NuxtLink
            v-for="(tab, index) in tabs"
            :key="index"
            :to="tab.to"
            class="flex flex-nowrap user-center-element items-center p-4 justify-between"
            @click="tiggerTinyUserCenter"
          >
            <div class="relative flex items-center">
              <SvgIcon class="w-4 h-4" :svg-name="tab.icon" />
              <div
                class="overflow-hidden user-center-label pl-4 uppercase text-xs"
              >
                {{ $t(tab.label) }}
              </div>
            </div>
            <div
              v-if="tab.label === 'messages' && isHasUnreadMessage"
              class="bg-failure w-fit h-4 fc-textBtn text-xs px-[6px] rounded-full"
            >
              {{ unreadInfo.TotalCount }}
            </div>
          </NuxtLink>
          <div
            v-if="!auth"
            class="w-full h-full absolute right-0 top-0 bg-black opacity-50"
          ></div>
        </div>
        <div
          v-if="!auth"
          class="absolute top-[50%] translate-y-[-50%] left-[50%] translate-x-[-50%] fc-text4 px-4 text-center w-full flex flex-col items-center"
        >
          <img :src="getAssetImage('assets/common/Login.png')" alt="" />
          <div class="whitespace-break-spaces mt-4">
            {{ $t("Please Login before using user center") }}
          </div>
        </div>
      </div>
      <span class="uppercase">
        <UtilsMobileLanguageSelection @expanded="onScrollToLastLangElement" />
      </span>
      <div
        v-if="auth"
        class="h-16 flex flex-nowrap user-center-element items-center p-4 border-t border-color1 cursor-pointer"
        @click="logout"
      >
        <div class="flex justify-between w-full items-center">
          <div class="flex items-center">
            <SvgIcon class="w-4 h-4" svg-name="icon-sign-out" />
            <div class="overflow-hidden user-center-label">
              <span class="pl-4">{{ $t("logout") }}</span>
            </div>
          </div>
          <font-awesome-icon
            icon="angle-right"
            class="m-language-collapse h-4 fc-text4"
          />
        </div>
      </div>
      <template v-if="isAppDownloadEnabled">
        <a :href="appUrl" class="sticky bottom-0" download>
          <div class="bg-theme-color !rounded-none relative">
            <div class="flex items-end justify-between h-16 gap-1 px-1">
              <div class="w-[68px] h-[68px] flex-shrink-0">
                <img
                  :src="
                    getAssetImage(
                      'assets/theme/new_black_theme/app_download.png'
                    )
                  "
                  alt=""
                />
              </div>
              <div class="flex items-center p-0 gap-1 h-16 z-[1]">
                <div class="flex flex-col justify-center items-start p-0 h-16">
                  <span class="app-download-title">{{ brandName }} APP</span>
                  <span class="app-download-content"
                    >Download <br />
                    our Android APP</span
                  >
                </div>
                <div class="h-[32px]">
                  <el-button
                    type="danger"
                    round
                    class="capitalize download-button"
                    >{{ $t("download") }}</el-button
                  >
                </div>
              </div>
            </div>
            <div
              class="bg-app-download !right-0 h-full !top-0 !left-[unset]"
              :style="`background-image: ${bgApp};`"
            ></div>
          </div>
        </a>
      </template>
    </div>
  </div>
</template>

<script setup lang="ts">
import useMenu from "@/composables/useMenu";
import { useHeaderComponent } from "@/composables/useTheme";
import { store } from "~/store";
import { memberMessageStore } from "~~/store/member-message";
import { useMessage } from "~~/composables/useMessage";

const isTinyUserCenterEnabled = ref(false);
const route = useRoute();
const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
const isHasUnreadMessage = computed(() => {
  return memberMessageStore.getters.isHasUnreadMessage;
});
const { unreadInfo, fetchMessages } = useMessage();
const tiggerTinyUserCenter = () => {
  isTinyUserCenterEnabled.value = !isTinyUserCenterEnabled.value;
};
onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});

const { auth, isReferralV2Enabled, logout, appUrl, isAppDownloadEnabled } =
  useHeaderComponent();
const {
  isCashPlayer,
  isShowDepositWithdrawal,
  isShowPromotion,
  isShowReferral,
} = useMenu();
const bgApp = `url(${commonHelper.getAssetImage(
  "assets/theme/new_black_theme/bg-app-download.png"
)})`;
const brandName = themePropertyHelper.getSingleThemeProperty(
  store.state.companyThemePropertiesFromApi.ThemeProperties,
  "seo_brand_name"
).Text;
const tabs = reactive([
  {
    to: "/deposit",
    label: "deposit",
    icon: "icon-deposit-v2",
    display: auth ? isCashPlayer.value && isShowDepositWithdrawal.value : true,
  },
  {
    to: "/withdrawal",
    label: "withdrawal",
    icon: "icon-withdraw",
    display: auth ? isCashPlayer.value && isShowDepositWithdrawal.value : true,
  },
  { to: "/wallet", label: "wallet", icon: "icon-wallet-v2", display: true },
  { to: "/account", label: "account", icon: "icon-account-v2", display: true },
  {
    to: "/transaction-history",
    label: "statement",
    icon: "icon-transaction-history-v2",
    display: true,
  },
  {
    to: "/bet-history",
    label: "bet_history",
    icon: "icon-bethistory-v2",
    display: true,
  },
  {
    to: "/my-promotion",
    label: "promotion",
    icon: "icon-promotion-v2",
    display: isShowPromotion.value,
  },
  {
    to: "/referral",
    label: "referral",
    icon: "icon-referral",
    display:
      isCashPlayer.value &&
      isShowReferral.value &&
      !isReferralV2Enabled.value &&
      isShowReferralPage.value,
  },
  {
    to: "/referral-v2",
    label: "referral",
    icon: "icon-referral",
    display: isReferralV2Enabled.value && isShowReferralPage.value,
  },
  {
    to: "/help-center",
    label: "help_center",
    icon: "icon-aboutus",
    display: true,
  },
  {
    to: "/messages",
    label: "messages",
    icon: "icon-message",
    display: true,
  },
]).filter((p) => p.display);
const onScrollToLastLangElement = (lastEl: HTMLElement) => {
  lastEl.scrollIntoView({
    behavior: "smooth",
    block: "start",
  });
};
const { getAssetImage } = commonHelper;
</script>
<style lang="scss">
.has-unread-message::before {
  content: "";
  position: absolute;
  top: 1px;
  right: -2px;
  width: 8px;
  height: 8px;
  border-radius: 50%;
  background: var(--failure);
  z-index: 100;
}
.mobile-tiny-user-center-style-2 {
  position: relative;
  .download-button {
    border: none;
    padding: 9px 12px;
    background: var(--primary) !important;
    span {
      color: var(--textBtn);
      font-size: 12px;
      font-style: normal;
      font-weight: 500;
      line-height: normal;
    }
  }
  .user-center-container {
    background: var(--background5);
    position: absolute;
    max-height: 0;
    top: 32px;
    right: -9px;
    white-space: nowrap;
    max-width: 0;
    transition: max-height 0.5s;
  }
  .user-center-container-active {
    width: 240px;
    max-width: 240px;
    height: fit-content;
    max-height: 80vh;
  }
  .tiny-button {
    background-color: var(--background5);
    rotate: 90deg;
    transition: rotate 0.3s;
    position: relative;
    z-index: 99;
  }
  .tiny-button-rotate {
    rotate: 0deg;
  }
  .tiny-dot {
    width: 2px;
    height: 2px;
    border-radius: 50%;
    background-color: var(--text5);
  }
  .tiny-dot-unread-message {
    position: absolute;
    top: -2px;
    right: -2px;
    width: 4px;
    height: 4px;
    border-radius: 50%;
    background: var(--failure);
    z-index: 100;
  }
  .user-center-element {
    backdrop-filter: blur(5px);
    transition: max-height 0.5s;
    svg {
      fill: var(--text5);
    }
    .user-center-label {
      color: var(--text5);
    }
  }
  .custom-backdrop-blur {
    -webkit-filter: blur(1.5px);
  }
  .m-profile-lang-seletion .el-collapse-item__header.is-active:after {
    all: unset;
  }
  .el-collapse-item__header {
    border-top: 1px solid var(--border);
    height: 64px;
  }
  .whitespace-break-spaces {
    white-space: break-spaces;
  }
}
</style>
